// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from delphi_mrr_msgs:msg/MrrStatusSwVersion.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "delphi_mrr_msgs/msg/mrr_status_sw_version.h"


#ifndef DELPHI_MRR_MSGS__MSG__DETAIL__MRR_STATUS_SW_VERSION__FUNCTIONS_H_
#define DELPHI_MRR_MSGS__MSG__DETAIL__MRR_STATUS_SW_VERSION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "delphi_mrr_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "delphi_mrr_msgs/msg/detail/mrr_status_sw_version__struct.h"

/// Initialize msg/MrrStatusSwVersion message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * delphi_mrr_msgs__msg__MrrStatusSwVersion
 * )) before or use
 * delphi_mrr_msgs__msg__MrrStatusSwVersion__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
bool
delphi_mrr_msgs__msg__MrrStatusSwVersion__init(delphi_mrr_msgs__msg__MrrStatusSwVersion * msg);

/// Finalize msg/MrrStatusSwVersion message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
void
delphi_mrr_msgs__msg__MrrStatusSwVersion__fini(delphi_mrr_msgs__msg__MrrStatusSwVersion * msg);

/// Create msg/MrrStatusSwVersion message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * delphi_mrr_msgs__msg__MrrStatusSwVersion__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
delphi_mrr_msgs__msg__MrrStatusSwVersion *
delphi_mrr_msgs__msg__MrrStatusSwVersion__create(void);

/// Destroy msg/MrrStatusSwVersion message.
/**
 * It calls
 * delphi_mrr_msgs__msg__MrrStatusSwVersion__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
void
delphi_mrr_msgs__msg__MrrStatusSwVersion__destroy(delphi_mrr_msgs__msg__MrrStatusSwVersion * msg);

/// Check for msg/MrrStatusSwVersion message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
bool
delphi_mrr_msgs__msg__MrrStatusSwVersion__are_equal(const delphi_mrr_msgs__msg__MrrStatusSwVersion * lhs, const delphi_mrr_msgs__msg__MrrStatusSwVersion * rhs);

/// Copy a msg/MrrStatusSwVersion message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
bool
delphi_mrr_msgs__msg__MrrStatusSwVersion__copy(
  const delphi_mrr_msgs__msg__MrrStatusSwVersion * input,
  delphi_mrr_msgs__msg__MrrStatusSwVersion * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
const rosidl_type_hash_t *
delphi_mrr_msgs__msg__MrrStatusSwVersion__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
const rosidl_runtime_c__type_description__TypeDescription *
delphi_mrr_msgs__msg__MrrStatusSwVersion__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
const rosidl_runtime_c__type_description__TypeSource *
delphi_mrr_msgs__msg__MrrStatusSwVersion__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
delphi_mrr_msgs__msg__MrrStatusSwVersion__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/MrrStatusSwVersion messages.
/**
 * It allocates the memory for the number of elements and calls
 * delphi_mrr_msgs__msg__MrrStatusSwVersion__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
bool
delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence__init(delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence * array, size_t size);

/// Finalize array of msg/MrrStatusSwVersion messages.
/**
 * It calls
 * delphi_mrr_msgs__msg__MrrStatusSwVersion__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
void
delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence__fini(delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence * array);

/// Create array of msg/MrrStatusSwVersion messages.
/**
 * It allocates the memory for the array and calls
 * delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence *
delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence__create(size_t size);

/// Destroy array of msg/MrrStatusSwVersion messages.
/**
 * It calls
 * delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
void
delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence__destroy(delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence * array);

/// Check for msg/MrrStatusSwVersion message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
bool
delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence__are_equal(const delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence * lhs, const delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence * rhs);

/// Copy an array of msg/MrrStatusSwVersion messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_delphi_mrr_msgs
bool
delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence__copy(
  const delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence * input,
  delphi_mrr_msgs__msg__MrrStatusSwVersion__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // DELPHI_MRR_MSGS__MSG__DETAIL__MRR_STATUS_SW_VERSION__FUNCTIONS_H_
